uninstall.sh 29 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RedHat 6+ Debian 7+ and Ubuntu 12+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/oneinstack/oneinstack
  10. export PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin:/usr/local/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RedHat 6+ Debian 7+ and Ubuntu 12+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit https://oneinstack.com #
  17. #######################################################################
  18. "
  19. # Check if user is root
  20. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  21. oneinstack_dir=$(dirname "`readlink -f $0`")
  22. pushd ${oneinstack_dir} > /dev/null
  23. . ./options.conf
  24. . ./include/color.sh
  25. . ./include/get_char.sh
  26. . ./include/check_dir.sh
  27. Show_Help() {
  28. echo
  29. echo "Usage: $0 command ...[parameters]....
  30. --help, -h Show this help message, More: https://oneinstack.com
  31. --quiet, -q quiet operation
  32. --all Uninstall All
  33. --web Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  34. --mysql Uninstall MySQL/MariaDB/Percona/AliSQL
  35. --postgresql Uninstall PostgreSQL
  36. --mongodb Uninstall MongoDB
  37. --php Uninstall PHP (PATH: ${php_install_dir})
  38. --mphp_ver [53~73] Uninstall another PHP version (PATH: ${php_install_dir}\${mphp_ver})
  39. --allphp Uninstall all PHP
  40. --phpcache Uninstall PHP opcode cache
  41. --php_extensions [ext name] Uninstall PHP extensions, include zendguardloader,ioncube,
  42. sourceguardian,imagick,gmagick,fileinfo,imap,ldap,phalcon,
  43. yaf,yar,redis,memcached,memcache,mongodb,swoole,xdebug
  44. --hhvm Uninstall HHVM
  45. --pureftpd Uninstall PureFtpd
  46. --redis Uninstall Redis-server
  47. --memcached Uninstall Memcached-server
  48. --phpmyadmin Uninstall phpMyAdmin
  49. --python Uninstall Python (PATH: ${python_install_dir})
  50. "
  51. }
  52. ARG_NUM=$#
  53. TEMP=`getopt -o hvVq --long help,version,quiet,all,web,mysql,postgresql,mongodb,php,mphp_ver:,allphp,phpcache,php_extensions:,hhvm,pureftpd,redis,memcached,phpmyadmin,python -- "$@" 2>/dev/null`
  54. [ $? != 0 ] && echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  55. eval set -- "${TEMP}"
  56. while :; do
  57. [ -z "$1" ] && break;
  58. case "$1" in
  59. -h|--help)
  60. Show_Help; exit 0
  61. ;;
  62. -q|--quiet)
  63. quiet_flag=y
  64. uninstall_flag=y
  65. shift 1
  66. ;;
  67. --all)
  68. all_flag=y
  69. web_flag=y
  70. mysql_flag=y
  71. postgresql_flag=y
  72. mongodb_flag=y
  73. allphp_flag=y
  74. hhvm_flag=y
  75. pureftpd_flag=y
  76. redis_flag=y
  77. memcached_flag=y
  78. phpmyadmin_flag=y
  79. python_flag=y
  80. shift 1
  81. ;;
  82. --web)
  83. web_flag=y; shift 1
  84. ;;
  85. --mysql)
  86. mysql_flag=y; shift 1
  87. ;;
  88. --postgresql)
  89. postgresql_flag=y; shift 1
  90. ;;
  91. --mongodb)
  92. mongodb_flag=y; shift 1
  93. ;;
  94. --php)
  95. php_flag=y; shift 1
  96. ;;
  97. --mphp_ver)
  98. mphp_ver=$2; mphp_flag=y; shift 2
  99. [[ ! "${mphp_ver}" =~ ^5[3-6]$|^7[0-3]$ ]] && { echo "${CWARNING}mphp_ver input error! Please only input number 53~73${CEND}"; exit 1; }
  100. ;;
  101. --allphp)
  102. allphp_flag=y; shift 1
  103. ;;
  104. --phpcache)
  105. phpcache_flag=y; shift 1
  106. ;;
  107. --php_extensions)
  108. php_extensions=$2; shift 2
  109. [ -n "`echo ${php_extensions} | grep -w zendguardloader`" ] && pecl_zendguardloader=1
  110. [ -n "`echo ${php_extensions} | grep -w ioncube`" ] && pecl_ioncube=1
  111. [ -n "`echo ${php_extensions} | grep -w sourceguardian`" ] && pecl_sourceguardian=1
  112. [ -n "`echo ${php_extensions} | grep -w imagick`" ] && pecl_imagick=1
  113. [ -n "`echo ${php_extensions} | grep -w gmagick`" ] && pecl_gmagick=1
  114. [ -n "`echo ${php_extensions} | grep -w fileinfo`" ] && pecl_fileinfo=1
  115. [ -n "`echo ${php_extensions} | grep -w imap`" ] && pecl_imap=1
  116. [ -n "`echo ${php_extensions} | grep -w ldap`" ] && pecl_ldap=1
  117. [ -n "`echo ${php_extensions} | grep -w phalcon`" ] && pecl_phalcon=1
  118. [ -n "`echo ${php_extensions} | grep -w yaf`" ] && pecl_yaf=1
  119. [ -n "`echo ${php_extensions} | grep -w yar`" ] && pecl_yar=1
  120. [ -n "`echo ${php_extensions} | grep -w redis`" ] && pecl_redis=1
  121. [ -n "`echo ${php_extensions} | grep -w memcached`" ] && pecl_memcached=1
  122. [ -n "`echo ${php_extensions} | grep -w memcache`" ] && pecl_memcache=1
  123. [ -n "`echo ${php_extensions} | grep -w mongodb`" ] && pecl_mongodb=1
  124. [ -n "`echo ${php_extensions} | grep -w swoole`" ] && pecl_swoole=1
  125. [ -n "`echo ${php_extensions} | grep -w xdebug`" ] && pecl_xdebug=1
  126. ;;
  127. --hhvm)
  128. hhvm_flag=y; shift 1
  129. ;;
  130. --pureftpd)
  131. pureftpd_flag=y; shift 1
  132. ;;
  133. --redis)
  134. redis_flag=y; shift 1
  135. ;;
  136. --memcached)
  137. memcached_flag=y; shift 1
  138. ;;
  139. --phpmyadmin)
  140. phpmyadmin_flag=y; shift 1
  141. ;;
  142. --python)
  143. python_flag=y; shift 1
  144. ;;
  145. --)
  146. shift
  147. ;;
  148. *)
  149. echo "${CWARNING}ERROR: unknown argument! ${CEND}" && Show_Help && exit 1
  150. ;;
  151. esac
  152. done
  153. Uninstall_status() {
  154. if [ "${quiet_flag}" != 'y' ]; then
  155. while :; do echo
  156. read -e -p "Do you want to uninstall? [y/n]: " uninstall_flag
  157. if [[ ! ${uninstall_flag} =~ ^[y,n]$ ]]; then
  158. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  159. else
  160. break
  161. fi
  162. done
  163. fi
  164. }
  165. Print_Warn() {
  166. echo
  167. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  168. }
  169. Print_web() {
  170. [ -d "${nginx_install_dir}" ] && echo ${nginx_install_dir}
  171. [ -d "${tengine_install_dir}" ] && echo ${tengine_install_dir}
  172. [ -d "${openresty_install_dir}" ] && echo ${openresty_install_dir}
  173. [ -e "/etc/init.d/nginx" ] && echo /etc/init.d/nginx
  174. [ -e "/lib/systemd/system/nginx.service" ] && echo /lib/systemd/system/nginx.service
  175. [ -e "/etc/logrotate.d/nginx" ] && echo /etc/logrotate.d/nginx
  176. [ -d "${apache_install_dir}" ] && echo ${apache_install_dir}
  177. [ -e "/lib/systemd/system/httpd.service" ] && echo /lib/systemd/system/httpd.service
  178. [ -e "/etc/init.d/httpd" ] && echo /etc/init.d/httpd
  179. [ -e "/etc/logrotate.d/apache" ] && echo /etc/logrotate.d/apache
  180. [ -d "${tomcat_install_dir}" ] && echo ${tomcat_install_dir}
  181. [ -e "/etc/init.d/tomcat" ] && echo /etc/init.d/tomcat
  182. [ -e "/etc/logrotate.d/tomcat" ] && echo /etc/logrotate.d/tomcat
  183. [ -d "/usr/java" ] && echo /usr/java
  184. [ -d "/usr/local/apr" ] && echo /usr/local/apr
  185. }
  186. Uninstall_Web() {
  187. [ -d "${nginx_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${nginx_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${nginx_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Nginx uninstall completed! ${CEND}"; }
  188. [ -d "${tengine_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${tengine_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${tengine_install_dir}/sbin:@@" /etc/profile; echo "${CMSG}Tengine uninstall completed! ${CEND}"; }
  189. [ -d "${openresty_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${openresty_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${openresty_install_dir}/nginx/sbin:@@" /etc/profile; echo "${CMSG}OpenResty uninstall completed! ${CEND}"; }
  190. [ -e "/lib/systemd/system/nginx.service" ] && { systemctl disable nginx > /dev/null 2>&1; rm -f /lib/systemd/system/nginx.service; }
  191. [ -d "${apache_install_dir}" ] && { service httpd stop > /dev/null 2>&1; rm -rf ${apache_install_dir} /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@${apache_install_dir}/bin:@@" /etc/profile; echo "${CMSG}Apache uninstall completed! ${CEND}"; }
  192. [ -e "/lib/systemd/system/httpd.service" ] && { systemctl disable httpd > /dev/null 2>&1; rm -f /lib/systemd/system/httpd.service; }
  193. [ -d "${tomcat_install_dir}" ] && { killall java > /dev/null 2>&1; chmod +x /etc/logrotate.d/tomcat; rm -rf ${tomcat_install_dir} /etc/init.d/tomcat /etc/logrotate.d/tomcat /usr/local/apr; echo "${CMSG}Tomcat uninstall completed! ${CEND}"; }
  194. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  195. [ -e "${wwwroot_dir}" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  196. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  197. sed -i 's@^backup_content=.*@backup_content=@' ./options.conf
  198. }
  199. Print_MySQL() {
  200. [ -e "${db_install_dir}" ] && echo ${db_install_dir}
  201. [ -e "/etc/init.d/mysqld" ] && echo /etc/init.d/mysqld
  202. [ -e "/etc/my.cnf" ] && echo /etc/my.cnf
  203. }
  204. Print_PostgreSQL() {
  205. [ -e "${pgsql_install_dir}" ] && echo ${pgsql_install_dir}
  206. [ -e "/etc/init.d/postgresql" ] && echo /etc/init.d/postgresql
  207. [ -e "/lib/systemd/system/postgresql.service" ] && echo /lib/systemd/system/postgresql.service
  208. }
  209. Print_MongoDB() {
  210. [ -e "${mongo_install_dir}" ] && echo ${mongo_install_dir}
  211. [ -e "/etc/init.d/mongod" ] && echo /etc/init.d/mongod
  212. [ -e "/lib/systemd/system/mongod.service" ] && echo /lib/systemd/system/mongod.service
  213. [ -e "/etc/mongod.conf" ] && echo /etc/mongod.conf
  214. }
  215. Uninstall_MySQL() {
  216. # uninstall mysql,mariadb,percona,alisql
  217. if [ -d "${db_install_dir}/support-files" ]; then
  218. service mysqld stop > /dev/null 2>&1
  219. rm -rf ${db_install_dir} /etc/init.d/mysqld /etc/my.cnf* /etc/ld.so.conf.d/*{mysql,mariadb,percona,alisql}*.conf
  220. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  221. [ -e "${db_data_dir}" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  222. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  223. sed -i "s@${db_install_dir}/bin:@@" /etc/profile
  224. echo "${CMSG}MySQL uninstall completed! ${CEND}"
  225. fi
  226. }
  227. Uninstall_PostgreSQL() {
  228. # uninstall postgresql
  229. if [ -e "${pgsql_install_dir}/bin/psql" ]; then
  230. service postgresql stop > /dev/null 2>&1
  231. rm -rf ${pgsql_install_dir} /etc/init.d/postgresql
  232. [ -e "/lib/systemd/system/postgresql.service" ] && { systemctl disable postgresql > /dev/null 2>&1; rm -f /lib/systemd/system/postgresql.service; }
  233. [ -e "${php_install_dir}/etc/php.d/07-pgsql.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-pgsql.ini
  234. id -u postgres >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel postgres
  235. [ -e "${pgsql_data_dir}" ] && /bin/mv ${pgsql_data_dir}{,$(date +%Y%m%d%H)}
  236. sed -i 's@^dbpostgrespwd=.*@dbpostgrespwd=@' ./options.conf
  237. sed -i "s@${pgsql_install_dir}/bin:@@" /etc/profile
  238. echo "${CMSG}PostgreSQL uninstall completed! ${CEND}"
  239. fi
  240. }
  241. Uninstall_MongoDB() {
  242. # uninstall mongodb
  243. if [ -e "${mongo_install_dir}/bin/mongo" ]; then
  244. service mongod stop > /dev/null 2>&1
  245. rm -rf ${mongo_install_dir} /etc/mongod.conf /etc/init.d/mongod /tmp/mongo*.sock
  246. [ -e "/lib/systemd/system/mongod.service" ] && { systemctl disable mongod > /dev/null 2>&1; rm -f /lib/systemd/system/mongod.service; }
  247. [ -e "${php_install_dir}/etc/php.d/07-mongo.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongo.ini
  248. [ -e "${php_install_dir}/etc/php.d/07-mongodb.ini" ] && rm -f ${php_install_dir}/etc/php.d/07-mongodb.ini
  249. id -u mongod > /dev/null 2>&1 ; [ $? -eq 0 ] && userdel mongod
  250. [ -e "${mongo_data_dir}" ] && /bin/mv ${mongo_data_dir}{,$(date +%Y%m%d%H)}
  251. sed -i 's@^dbmongopwd=.*@dbmongopwd=@' ./options.conf
  252. sed -i "s@${mongo_install_dir}/bin:@@" /etc/profile
  253. echo "${CMSG}MongoDB uninstall completed! ${CEND}"
  254. fi
  255. }
  256. Print_PHP() {
  257. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  258. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  259. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  260. }
  261. Print_MPHP() {
  262. [ -e "${php_install_dir}${mphp_ver}" ] && echo ${php_install_dir}${mphp_ver}
  263. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && echo /etc/init.d/php${mphp_ver}-fpm
  264. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && echo /lib/systemd/system/php${mphp_ver}-fpm.service
  265. }
  266. Print_ALLPHP() {
  267. [ -e "${php_install_dir}" ] && echo ${php_install_dir}
  268. [ -e "/etc/init.d/php-fpm" ] && echo /etc/init.d/php-fpm
  269. [ -e "/lib/systemd/system/php-fpm.service" ] && echo /lib/systemd/system/php-fpm.service
  270. for php_ver in 53 54 55 56 70 71 72 73; do
  271. [ -e "${php_install_dir}${php_ver}" ] && echo ${php_install_dir}${php_ver}
  272. [ -e "/etc/init.d/php${php_ver}-fpm" ] && echo /etc/init.d/php${php_ver}-fpm
  273. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && echo /lib/systemd/system/php${php_ver}-fpm.service
  274. done
  275. [ -e "${imagick_install_dir}" ] && echo ${imagick_install_dir}
  276. [ -e "${gmagick_install_dir}" ] && echo ${gmagick_install_dir}
  277. [ -e "${curl_install_dir}" ] && echo ${curl_install_dir}
  278. }
  279. Uninstall_PHP() {
  280. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  281. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  282. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  283. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  284. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  285. }
  286. Uninstall_MPHP() {
  287. [ -e "/etc/init.d/php${mphp_ver}-fpm" ] && { service php${mphp_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${mphp_ver}-fpm; }
  288. [ -e "/lib/systemd/system/php${mphp_ver}-fpm.service" ] && { systemctl stop php${mphp_ver}-fpm > /dev/null 2>&1; systemctl disable php${mphp_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${mphp_ver}-fpm.service; }
  289. [ -e "${php_install_dir}${mphp_ver}" ] && { rm -rf ${php_install_dir}${mphp_ver}; echo "${CMSG}PHP${mphp_ver} uninstall completed! ${CEND}"; }
  290. }
  291. Uninstall_ALLPHP() {
  292. [ -e "/etc/init.d/php-fpm" ] && { service php-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php-fpm; }
  293. [ -e "/lib/systemd/system/php-fpm.service" ] && { systemctl stop php-fpm > /dev/null 2>&1; systemctl disable php-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php-fpm.service; }
  294. [ -e "${apache_install_dir}/conf/httpd.conf" ] && [ -n "`grep libphp ${apache_install_dir}/conf/httpd.conf`" ] && sed -i '/libphp/d' ${apache_install_dir}/conf/httpd.conf
  295. [ -e "${php_install_dir}" ] && { rm -rf ${php_install_dir}; echo "${CMSG}PHP uninstall completed! ${CEND}"; }
  296. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  297. for php_ver in 53 54 55 56 70 71 72 73; do
  298. [ -e "/etc/init.d/php${php_ver}-fpm" ] && { service php${php_ver}-fpm stop > /dev/null 2>&1; rm -f /etc/init.d/php${php_ver}-fpm; }
  299. [ -e "/lib/systemd/system/php${php_ver}-fpm.service" ] && { systemctl stop php${php_ver}-fpm > /dev/null 2>&1; systemctl disable php${php_ver}-fpm > /dev/null 2>&1; rm -f /lib/systemd/system/php${php_ver}-fpm.service; }
  300. [ -e "${php_install_dir}${php_ver}" ] && { rm -rf ${php_install_dir}${php_ver}; echo "${CMSG}PHP${php_ver} uninstall completed! ${CEND}"; }
  301. done
  302. [ -e "${imagick_install_dir}" ] && rm -rf ${imagick_install_dir}
  303. [ -e "${gmagick_install_dir}" ] && rm -rf ${gmagick_install_dir}
  304. [ -e "${curl_install_dir}" ] && rm -rf ${curl_install_dir}
  305. }
  306. Uninstall_PHPcache() {
  307. . include/zendopcache.sh
  308. . include/xcache.sh
  309. . include/apcu.sh
  310. . include/eaccelerator.sh
  311. Uninstall_ZendOPcache
  312. Uninstall_XCache
  313. Uninstall_APCU
  314. Uninstall_eAccelerator
  315. # reload php
  316. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  317. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  318. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  319. }
  320. Uninstall_PHPext() {
  321. # ZendGuardLoader
  322. if [ "${pecl_zendguardloader}" == '1' ]; then
  323. . include/ZendGuardLoader.sh
  324. Uninstall_ZendGuardLoader
  325. fi
  326. # ioncube
  327. if [ "${pecl_ioncube}" == '1' ]; then
  328. . include/ioncube.sh
  329. Uninstall_ionCube
  330. fi
  331. # SourceGuardian
  332. if [ "${pecl_sourceguardian}" == '1' ]; then
  333. . include/sourceguardian.sh
  334. Uninstall_SourceGuardian
  335. fi
  336. # imagick
  337. if [ "${pecl_imagick}" == '1' ]; then
  338. . include/ImageMagick.sh
  339. Uninstall_ImageMagick
  340. Uninstall_pecl_imagick
  341. fi
  342. # gmagick
  343. if [ "${pecl_gmagick}" == '1' ]; then
  344. . include/GraphicsMagick.sh
  345. Uninstall_GraphicsMagick
  346. Uninstall_pecl_gmagick
  347. fi
  348. # fileinfo
  349. if [ "${pecl_fileinfo}" == '1' ]; then
  350. . include/pecl_fileinfo.sh
  351. Uninstall_pecl_fileinfo
  352. fi
  353. # imap
  354. if [ "${pecl_imap}" == '1' ]; then
  355. . include/pecl_imap.sh
  356. Uninstall_pecl_imap
  357. fi
  358. # ldap
  359. if [ "${pecl_ldap}" == '1' ]; then
  360. . include/pecl_ldap.sh
  361. Uninstall_pecl_ldap
  362. fi
  363. # phalcon
  364. if [ "${pecl_phalcon}" == '1' ]; then
  365. . include/pecl_phalcon.sh
  366. Uninstall_pecl_phalcon
  367. fi
  368. # yaf
  369. if [ "${pecl_yaf}" == '1' ]; then
  370. . include/pecl_yaf.sh
  371. Uninstall_pecl_yaf 2>&1 | tee -a ${oneinstack_dir}/install.log
  372. fi
  373. # yar
  374. if [ "${pecl_yar}" == '1' ]; then
  375. . include/pecl_yar.sh
  376. Uninstall_pecl_yar 2>&1 | tee -a ${oneinstack_dir}/install.log
  377. fi
  378. # pecl_memcached
  379. if [ "${pecl_memcached}" == '1' ]; then
  380. . include/memcached.sh
  381. Uninstall_pecl_memcached
  382. fi
  383. # pecl_memcache
  384. if [ "${pecl_memcache}" == '1' ]; then
  385. . include/memcached.sh
  386. Uninstall_pecl_memcache
  387. fi
  388. # pecl_redis
  389. if [ "${pecl_redis}" == '1' ]; then
  390. . include/redis.sh
  391. Uninstall_pecl_redis
  392. fi
  393. # pecl_mongodb
  394. if [ "${pecl_mongodb}" == '1' ]; then
  395. . include/pecl_mongodb.sh
  396. Uninstall_pecl_mongodb
  397. fi
  398. # swoole
  399. if [ "${pecl_swoole}" == '1' ]; then
  400. . include/pecl_swoole.sh
  401. Uninstall_pecl_swoole
  402. fi
  403. # xdebug
  404. if [ "${pecl_xdebug}" == '1' ]; then
  405. . include/pecl_xdebug.sh
  406. Uninstall_pecl_xdebug
  407. fi
  408. # reload php
  409. [ -e "${php_install_dir}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php-fpm || service php-fpm reload; }
  410. [ -n "${mphp_ver}" -a -e "${php_install_dir}${mphp_ver}/sbin/php-fpm" ] && { [ -e "/bin/systemctl" ] && systemctl reload php${mphp_ver}-fpm || service php${mphp_ver}-fpm reload; }
  411. [ -e "${apache_install_dir}/bin/apachectl" ] && ${apache_install_dir}/bin/apachectl -k graceful
  412. }
  413. Menu_PHPext() {
  414. while :; do
  415. echo 'Please select uninstall PHP extensions:'
  416. echo -e "\t${CMSG} 0${CEND}. Do not uninstall"
  417. echo -e "\t${CMSG} 1${CEND}. Uninstall zendguardloader(PHP<=5.6)"
  418. echo -e "\t${CMSG} 2${CEND}. Uninstall ioncube"
  419. echo -e "\t${CMSG} 3${CEND}. Uninstall sourceguardian(PHP<=7.2)"
  420. echo -e "\t${CMSG} 4${CEND}. Uninstall imagick"
  421. echo -e "\t${CMSG} 5${CEND}. Uninstall gmagick"
  422. echo -e "\t${CMSG} 6${CEND}. Uninstall fileinfo"
  423. echo -e "\t${CMSG} 7${CEND}. Uninstall imap"
  424. echo -e "\t${CMSG} 8${CEND}. Uninstall ldap"
  425. echo -e "\t${CMSG} 9${CEND}. Uninstall phalcon(PHP>=5.5)"
  426. echo -e "\t${CMSG}10${CEND}. Uninstall redis"
  427. echo -e "\t${CMSG}11${CEND}. Uninstall memcached"
  428. echo -e "\t${CMSG}12${CEND}. Uninstall memcache"
  429. echo -e "\t${CMSG}13${CEND}. Uninstall mongodb"
  430. echo -e "\t${CMSG}14${CEND}. Uninstall swoole"
  431. echo -e "\t${CMSG}15${CEND}. Uninstall xdebug(PHP>=5.5)"
  432. read -e -p "Please input a number:(Default 0 press Enter) " phpext_option
  433. phpext_option=${phpext_option:-0}
  434. [ "${phpext_option}" == '0' ] && break
  435. array_phpext=(${phpext_option})
  436. array_all=(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15)
  437. for v in ${array_phpext[@]}
  438. do
  439. [ -z "`echo ${array_all[@]} | grep -w ${v}`" ] && phpext_flag=1
  440. done
  441. if [ "${phpext_flag}" == '1' ]; then
  442. unset phpext_flag
  443. echo; echo "${CWARNING}input error! Please only input number 1 2 3 14 and so on${CEND}"; echo
  444. continue
  445. else
  446. [ -n "`echo ${array_phpext[@]} | grep -w 1`" ] && pecl_zendguardloader=1
  447. [ -n "`echo ${array_phpext[@]} | grep -w 2`" ] && pecl_ioncube=1
  448. [ -n "`echo ${array_phpext[@]} | grep -w 3`" ] && pecl_sourceguardian=1
  449. [ -n "`echo ${array_phpext[@]} | grep -w 4`" ] && pecl_imagick=1
  450. [ -n "`echo ${array_phpext[@]} | grep -w 5`" ] && pecl_gmagick=1
  451. [ -n "`echo ${array_phpext[@]} | grep -w 6`" ] && pecl_fileinfo=1
  452. [ -n "`echo ${array_phpext[@]} | grep -w 7`" ] && pecl_imap=1
  453. [ -n "`echo ${array_phpext[@]} | grep -w 8`" ] && pecl_ldap=1
  454. [ -n "`echo ${array_phpext[@]} | grep -w 9`" ] && pecl_phalcon=1
  455. [ -n "`echo ${array_phpext[@]} | grep -w 10`" ] && pecl_redis=1
  456. [ -n "`echo ${array_phpext[@]} | grep -w 11`" ] && pecl_memcached=1
  457. [ -n "`echo ${array_phpext[@]} | grep -w 12`" ] && pecl_memcache=1
  458. [ -n "`echo ${array_phpext[@]} | grep -w 13`" ] && pecl_mongodb=1
  459. [ -n "`echo ${array_phpext[@]} | grep -w 14`" ] && pecl_swoole=1
  460. [ -n "`echo ${array_phpext[@]} | grep -w 15`" ] && pecl_xdebug=1
  461. break
  462. fi
  463. done
  464. }
  465. Print_HHVM() {
  466. [ -e "/usr/bin/hhvm" ] && echo /usr/bin/hhvm
  467. [ -e "/etc/hhvm" ] && echo /etc/hhvm
  468. [ -e "/var/log/hhvm" ] && echo /var/log/hhvm
  469. [ -e "/lib/systemd/system/hhvm.service" ] && echo /lib/systemd/system/hhvm.service
  470. [ -e "/etc/supervisord.conf" ] && echo /etc/supervisord.conf
  471. [ -e "/etc/init.d/supervisord" ] && echo /etc/init.d/supervisord
  472. }
  473. Uninstall_HHVM() {
  474. [ -e "/lib/systemd/system/hhvm.service" ] && { systemctl disable hhvm > /dev/null 2>&1; rm -f /lib/systemd/system/hhvm.service; }
  475. [ -e "/etc/init.d/supervisord" ] && { service supervisord stop > /dev/null 2>&1; rm -f /etc/supervisord.conf /etc/init.d/supervisord; }
  476. [ -e "/usr/bin/hhvm" ] && { rpm -e hhvm; rm -rf /etc/hhvm /var/log/hhvm /usr/bin/hhvm; echo "${CMSG}HHVM uninstall completed! ${CEND}"; }
  477. }
  478. Print_PureFtpd() {
  479. [ -e "${pureftpd_install_dir}" ] && echo ${pureftpd_install_dir}
  480. [ -e "/etc/init.d/pureftpd" ] && echo /etc/init.d/pureftpd
  481. [ -e "/lib/systemd/system/pureftpd.service" ] && echo /lib/systemd/system/pureftpd.service
  482. }
  483. Uninstall_PureFtpd() {
  484. [ -e "${pureftpd_install_dir}" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf ${pureftpd_install_dir} /etc/init.d/pureftpd; echo "${CMSG}Pureftpd uninstall completed! ${CEND}"; }
  485. [ -e "/lib/systemd/system/pureftpd.service" ] && { systemctl disable pureftpd > /dev/null 2>&1; rm -f /lib/systemd/system/pureftpd.service; }
  486. }
  487. Print_Redis_server() {
  488. [ -e "${redis_install_dir}" ] && echo ${redis_install_dir}
  489. [ -e "/etc/init.d/redis-server" ] && echo /etc/init.d/redis-server
  490. [ -e "/lib/systemd/system/redis-server.service" ] && echo /lib/systemd/system/redis-server.service
  491. }
  492. Uninstall_Redis_server() {
  493. [ -e "${redis_install_dir}" ] && { service redis-server stop > /dev/null 2>&1; rm -rf ${redis_install_dir} /etc/init.d/redis-server /usr/local/bin/redis-*; echo "${CMSG}Redis uninstall completed! ${CEND}"; }
  494. [ -e "/lib/systemd/system/redis-server.service" ] && { systemctl disable redis-server > /dev/null 2>&1; rm -f /lib/systemd/system/redis-server.service; }
  495. }
  496. Print_Memcached_server() {
  497. [ -e "${memcached_install_dir}" ] && echo ${memcached_install_dir}
  498. [ -e "/etc/init.d/memcached" ] && echo /etc/init.d/memcached
  499. [ -e "/usr/bin/memcached" ] && echo /usr/bin/memcached
  500. }
  501. Uninstall_Memcached_server() {
  502. [ -e "${memcached_install_dir}" ] && { service memcached stop > /dev/null 2>&1; rm -rf ${memcached_install_dir} /etc/init.d/memcached /usr/bin/memcached; echo "${CMSG}Memcached uninstall completed! ${CEND}"; }
  503. }
  504. Print_phpMyAdmin() {
  505. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && echo ${wwwroot_dir}/default/phpMyAdmin
  506. }
  507. Uninstall_phpMyAdmin() {
  508. [ -d "${wwwroot_dir}/default/phpMyAdmin" ] && rm -rf ${wwwroot_dir}/default/phpMyAdmin
  509. }
  510. Print_openssl() {
  511. [ -d "${openssl_install_dir}" ] && echo ${openssl_install_dir}
  512. }
  513. Uninstall_openssl() {
  514. [ -d "${openssl_install_dir}" ] && rm -rf ${openssl_install_dir}
  515. }
  516. Print_Python() {
  517. [ -d "${python_install_dir}" ] && echo ${python_install_dir}
  518. }
  519. Menu() {
  520. while :; do
  521. printf "
  522. What Are You Doing?
  523. \t${CMSG} 0${CEND}. Uninstall All
  524. \t${CMSG} 1${CEND}. Uninstall Nginx/Tengine/OpenResty/Apache/Tomcat
  525. \t${CMSG} 2${CEND}. Uninstall MySQL/MariaDB/Percona/AliSQL
  526. \t${CMSG} 3${CEND}. Uninstall PostgreSQL
  527. \t${CMSG} 4${CEND}. Uninstall MongoDB
  528. \t${CMSG} 5${CEND}. Uninstall all PHP
  529. \t${CMSG} 6${CEND}. Uninstall PHP opcode cache
  530. \t${CMSG} 7${CEND}. Uninstall PHP extensions
  531. \t${CMSG} 8${CEND}. Uninstall HHVM
  532. \t${CMSG} 9${CEND}. Uninstall PureFtpd
  533. \t${CMSG}10${CEND}. Uninstall Redis
  534. \t${CMSG}11${CEND}. Uninstall Memcached
  535. \t${CMSG}12${CEND}. Uninstall phpMyAdmin
  536. \t${CMSG}13${CEND}. Uninstall Python (PATH: ${python_install_dir})
  537. \t${CMSG} q${CEND}. Exit
  538. "
  539. echo
  540. read -e -p "Please input the correct option: " Number
  541. if [[ ! "${Number}" =~ ^[0-9,q]$|^1[0-3]$ ]]; then
  542. echo "${CWARNING}input error! Please only input 0~13 and q${CEND}"
  543. else
  544. case "$Number" in
  545. 0)
  546. Print_Warn
  547. Print_web
  548. Print_MySQL
  549. Print_PostgreSQL
  550. Print_MongoDB
  551. Print_ALLPHP
  552. Print_HHVM
  553. Print_PureFtpd
  554. Print_Redis_server
  555. Print_Memcached_server
  556. Print_openssl
  557. Print_phpMyAdmin
  558. Print_Python
  559. Uninstall_status
  560. if [ "${uninstall_flag}" == 'y' ]; then
  561. Uninstall_Web
  562. Uninstall_MySQL
  563. Uninstall_PostgreSQL
  564. Uninstall_MongoDB
  565. Uninstall_ALLPHP
  566. Uninstall_HHVM
  567. Uninstall_PureFtpd
  568. Uninstall_Redis_server
  569. Uninstall_Memcached_server
  570. Uninstall_openssl
  571. Uninstall_phpMyAdmin
  572. . include/python.sh; Uninstall_Python
  573. else
  574. exit
  575. fi
  576. ;;
  577. 1)
  578. Print_Warn
  579. Print_web
  580. Uninstall_status
  581. [ "${uninstall_flag}" == 'y' ] && Uninstall_Web || exit
  582. ;;
  583. 2)
  584. Print_Warn
  585. Print_MySQL
  586. Uninstall_status
  587. [ "${uninstall_flag}" == 'y' ] && Uninstall_MySQL || exit
  588. ;;
  589. 3)
  590. Print_Warn
  591. Print_PostgreSQL
  592. Uninstall_status
  593. [ "${uninstall_flag}" == 'y' ] && Uninstall_PostgreSQL || exit
  594. ;;
  595. 4)
  596. Print_Warn
  597. Print_MongoDB
  598. Uninstall_status
  599. [ "${uninstall_flag}" == 'y' ] && Uninstall_MongoDB || exit
  600. ;;
  601. 5)
  602. Print_ALLPHP
  603. Uninstall_status
  604. [ "${uninstall_flag}" == 'y' ] && Uninstall_ALLPHP || exit
  605. ;;
  606. 6)
  607. Uninstall_status
  608. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPcache || exit
  609. ;;
  610. 7)
  611. Menu_PHPext
  612. [ "${phpext_option}" != '0' ] && Uninstall_status
  613. [ "${uninstall_flag}" == 'y' ] && Uninstall_PHPext || exit
  614. ;;
  615. 8)
  616. Print_HHVM
  617. Uninstall_status
  618. [ "${uninstall_flag}" == 'y' ] && Uninstall_HHVM || exit
  619. ;;
  620. 9)
  621. Print_PureFtpd
  622. Uninstall_status
  623. [ "${uninstall_flag}" == 'y' ] && Uninstall_PureFtpd || exit
  624. ;;
  625. 10)
  626. Print_Redis_server
  627. Uninstall_status
  628. [ "${uninstall_flag}" == 'y' ] && Uninstall_Redis_server || exit
  629. ;;
  630. 11)
  631. Print_Memcached_server
  632. Uninstall_status
  633. [ "${uninstall_flag}" == 'y' ] && Uninstall_Memcached_server || exit
  634. ;;
  635. 12)
  636. Print_phpMyAdmin
  637. Uninstall_status
  638. [ "${uninstall_flag}" == 'y' ] && Uninstall_phpMyAdmin || exit
  639. ;;
  640. 13)
  641. Print_Python
  642. Uninstall_status
  643. [ "${uninstall_flag}" == 'y' ] && { . include/python.sh; Uninstall_Python; } || exit
  644. ;;
  645. q)
  646. exit
  647. ;;
  648. esac
  649. fi
  650. done
  651. }
  652. if [ ${ARG_NUM} == 0 ]; then
  653. Menu
  654. else
  655. [ "${web_flag}" == 'y' ] && Print_web
  656. [ "${mysql_flag}" == 'y' ] && Print_MySQL
  657. [ "${postgresql_flag}" == 'y' ] && Print_PostgreSQL
  658. [ "${mongodb_flag}" == 'y' ] && Print_MongoDB
  659. if [ "${allphp_flag}" == 'y' ]; then
  660. Print_ALLPHP
  661. else
  662. [ "${php_flag}" == 'y' ] && Print_PHP
  663. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Print_MPHP
  664. fi
  665. [ "${hhvm_flag}" == 'y' ] && Print_HHVM
  666. [ "${pureftpd_flag}" == 'y' ] && Print_PureFtpd
  667. [ "${redis_flag}" == 'y' ] && Print_Redis_server
  668. [ "${memcached_flag}" == 'y' ] && Print_Memcached_server
  669. [ "${phpmyadmin_flag}" == 'y' ] && Print_phpMyAdmin
  670. [ "${python_flag}" == 'y' ] && Print_Python
  671. [ "${all_flag}" == 'y' ] && Print_openssl
  672. Uninstall_status
  673. if [ "${uninstall_flag}" == 'y' ]; then
  674. [ "${web_flag}" == 'y' ] && Uninstall_Web
  675. [ "${mysql_flag}" == 'y' ] && Uninstall_MySQL
  676. [ "${postgresql_flag}" == 'y' ] && Uninstall_PostgreSQL
  677. [ "${mongodb_flag}" == 'y' ] && Uninstall_MongoDB
  678. if [ "${allphp_flag}" == 'y' ]; then
  679. Uninstall_ALLPHP
  680. else
  681. [ "${php_flag}" == 'y' ] && Uninstall_PHP
  682. [ "${phpcache_flag}" == 'y' ] && Uninstall_PHPcache
  683. [ -n "${php_extensions}" ] && Uninstall_PHPext
  684. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" != 'y' ] && [ -z "${php_extensions}" ] && Uninstall_MPHP
  685. [ "${mphp_flag}" == 'y' ] && [ "${phpcache_flag}" == 'y' ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPcache; }
  686. [ "${mphp_flag}" == 'y' ] && [ -n "${php_extensions}" ] && { php_install_dir=${php_install_dir}${mphp_ver}; Uninstall_PHPext; }
  687. fi
  688. [ "${hhvm_flag}" == 'y' ] && Uninstall_HHVM
  689. [ "${pureftpd_flag}" == 'y' ] && Uninstall_PureFtpd
  690. [ "${redis_flag}" == 'y' ] && Uninstall_Redis_server
  691. [ "${memcached_flag}" == 'y' ] && Uninstall_Memcached_server
  692. [ "${phpmyadmin_flag}" == 'y' ] && Uninstall_phpMyAdmin
  693. [ "${python_flag}" == 'y' ] && { . include/python.sh; Uninstall_Python; }
  694. [ "${all_flag}" == 'y' ] && Uninstall_openssl
  695. fi
  696. fi